package com.me.common.ecs;

public abstract class EntitySystem {

    private long typeBits;

    public EntitySystem(Class<? extends Component>... components) {
        typeBits = ComponentType.getMaskBits(components);
    }

    /**
     * @return the type mask for this system. Only entities containing all component types specified
     * by the mask will be processed by it.
     */
    public long getTypeMask() {
        return typeBits;
    }

    public void preProcessing() {}

    public abstract void processEntity(Entity entity, float dt);

    public void postProcessing() {}

}
